/* connection.h */

#include <sys/select.h>

#define SENT_TIME	4	/* Watch over 4 sec */
#define TXSIZE		1460	/* max ethernet size tcp payload */
#define MAXTXPERLOOP	30
#define BUFFERSIZE	16384	/* (16k) buffer size for reading */
#define MAXTEXTLENGTH	512

extern time_t Curtime;

extern fd_set Readset;
extern fd_set Writeset;

extern int Timeout;
extern unsigned int Transfer_maxspeed;
extern unsigned int Overall_send_speed;
extern unsigned int Overall_recv_speed;
extern unsigned long Bytes_send[ SENT_TIME ];
extern unsigned long Bytes_recv[ SENT_TIME ];
extern const char *Vhost;

my_connection_t *connection_initvalues(void);
void connection_close(my_connection_t * const con, const char * const msg);
int connection_open_listen(my_connection_t * const con);
void connection_open_connect(my_connection_t * const con);
void connection_accept(my_connection_t * const con);
void connection_connected(my_connection_t * const con);
void connection_send(my_connection_t * const con);
void connection_recv(my_connection_t * const con);
void connection_flush(my_connection_t * const con);

/* eof */
