/* my_types.h */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

typedef enum
{
  TRANSFER_STATE_UNUSED,
  TRANSFER_STATE_RESUME,
  TRANSFER_STATE_LISTENING,
  TRANSFER_STATE_CONNECTING,
  TRANSFER_STATE_RUNNING,
  TRANSFER_STATE_WAITING,
  TRANSFER_STATE_DONE
} transfer_state_e;

typedef enum
{
  TRANSFER_MODE_UNUSED,
  TRANSFER_MODE_RECV,
  TRANSFER_MODE_SEND,
} transfer_mode_e;

typedef union {
  struct sockaddr sa;
  struct sockaddr_in sin;
  struct sockaddr_in6 sin6;
} my_sockaddr_union_t;

typedef struct {
  transfer_state_e state;
  transfer_mode_e mode;
  int family;
  int listensocket;
  int clientsocket;
  int overlimit;
  int file_fd;
  char *remoteaddr;
  char *localaddr;
  char *file;
  long tx_bucket;
  time_t lastcontact;
  time_t connecttime;
  unsigned long long connecttimems;
  off_t file_size;
  off_t file_fd_location;
  off_t bytessent;
  off_t bytesgot;
  off_t lastack;
  unsigned short localport;
  unsigned short remoteport;
  my_sockaddr_union_t remote;
  my_sockaddr_union_t local;
} my_connection_t;

/* eof */
